(* ---------------------------------------------------------------------------- *)

(* An atom is an object with unique identity. *)

type atom

(* ---------------------------------------------------------------------------- *)

(* [fresh] produces a fresh atom. *)

val fresh: Identifier.t -> atom

(* ---------------------------------------------------------------------------- *)

(* Accessors. *)

val identifier: atom -> Identifier.t

(* ---------------------------------------------------------------------------- *)

(* Comparison. *)

val equal: atom -> atom -> bool
val compare: atom -> atom -> int

(* ---------------------------------------------------------------------------- *)

(* Sets and maps over atoms. *)

module AtomSet : Set.S with type elt = atom

module AtomMap : sig
  include Map.S with type key = atom
  val to_list: 'a t -> (key * 'a) list
  val of_list: (key * 'a) list -> 'a t
end

